8VC Venture Cup 2016 - Elimination Round E. Simple Skewness(枚举+三分)

题目链接:点击打开链接

题意:给你n个数, 要求选若干个数, 使得这些数的平均数减去中位数尽量大。

思路:由于该题没有顺序问题, 排好序之后我们可以枚举中位数, 可以证明, 奇数个数一定比偶数优,然后三分中位数左右区间长度x(数的个数), 在中位数的右边选最大的x个数, 在左边也选最大的x个, 这样, 随着区间长度的增加, 平均数将先增大后减小, 或者一直减小,或者一直增大。

为什么呢? 假设第一次的区间长度是1, 那么我们选择了两边最大的两个数, 假设他们加起来取平均大于中位数, 那么对答案有正的影响,提高了平均数的大小, 但是第二次取得两个数加和一定小于等于第一次, 当某一次, 如果加和平均数比中位数小, 那么从此就会不断产生负的影响,拉低了平均数, 所以答案又下降了,  所以是先增加后减小。 那么最大平均数就是先增加后减小的。

细节参见代码:

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
#include<string>
#include<vector>
#include<stack>
#include<bitset>
#include<cstdlib>
#include<cmath>
#include<set>
#include<list>
#include<deque>
#include<map>
#include<queue>
#define Max(a,b) ((a)>(b)?(a):(b))
#define Min(a,b) ((a)<(b)?(a):(b))
using namespace std;
typedef long long ll;
const double PI = acos(-1.0);
const double eps = 1e-6;
const int mod = 1000000000 + 7;
const double INF = 1000000000;
const int maxn = 201100;
int T,n,m,a[maxn];
ll sum[maxn];
void pre() {
    sort(a+1, a+n+1);
    for(int i=1;i<=n;i++) sum[i] = sum[i-1] + a[i];

}
int main() {
    scanf("%d",&n);
    for(int i=1;i<=n;i++) scanf("%d",&a[i]);
    pre();
    ll pos = 1, len = 0;
    ll ans = 0;
    for(int i=2;i<=n-1;i++) {
        ll l = 1, r = min(i-1, n - i), mid, mmid;
        for(int j=1;j<=100;j++) {
            mid = (2*l + r) / 3;
            mmid = (l + 2*r + 2) / 3;
            ll m1 = (sum[i] - sum[i-mid-1] + sum[n] - sum[n-mid]);
            ll m2 = (sum[i] - sum[i-mmid-1] + sum[n] - sum[n-mmid]);
            if(m2*(mid*2+1) <= m1*(mmid*2+1)) r = mmid - 1;
            else l = mid + 1;
        }
        double cur = (double)(sum[i] - sum[i-l-1] + sum[n] - sum[n-l]) - (2*l+1)*a[i];
        if(ans*(2*l+1) < cur*(2*len+1)) { //为了避免精度问题, 转化为整数比较
            ans = cur;
            len = l;
            pos = i;
        }
    }
    printf("%I64d\n",len*2+1);
    for(int i=pos-len;i<=pos;i++) printf("%d ",a[i]);
    for(int i=n-len+1;i<=n;i++) printf("%d%c",a[i],i == n ? '\n' : ' ');
    return 0;
}

时间: 2024-10-03 02:17:03

8VC Venture Cup 2016 - Elimination Round E. Simple Skewness(枚举+三分)的相关文章

8VC Venture Cup 2016 - Elimination Round

在家补补题   模拟 A - Robot Sequence #include <bits/stdc++.h> char str[202]; void move(int &x, int &y, char ch) { if (ch == 'U') x--; if (ch == 'D') x++; if (ch == 'L') y--; if (ch == 'R') y++; } int main(void) { int n; scanf ("%d", &

codeforces 8VC Venture Cup 2016 - Elimination Round C. Lieges of Legendre

C. Lieges of Legendre 题意:给n,m表示有n个为2的倍数,m个为3的倍数:问这n+m个数不重复时的最大值 最小为多少? 数据:(0 ≤ n, m ≤ 1 000 000, n + m > 0) ps:很水的题,主要是策略: 思路:由于里面每隔6就会重复一次,不好直接模拟,并且模拟的效率很低,那就二分吧!二分即上界为2单独的最大倍数与3单独时的最大倍数之和,下界为前面二者的max;之后利用判断是否mid/2 >= n && mid/3 >= m &am

Codeforces 8VC Venture Cup 2016 - Elimination Round F. Group Projects 差分DP*****

F. Group Projects There are n students in a class working on group projects. The students will divide into groups (some students may be in groups alone), work on their independent pieces, and then discuss the results together. It takes the i-th stude

8VC Venture Cup 2016 - Final Round (Div2) E

贪心.当前位置满油可达的gas station中,如果有比它小的,则加油至第一个比他小的.没有,则加满油,先到达这些station中最小的.注意数的范围即可. #include <iostream> #include <cstdio> #include <cstring> #include <algorithm> #define LL long long using namespace std; const int MAXN = 200050; int d,

Codeforces Round #393 (Div. 2) (8VC Venture Cup 2017 - Final Round Div. 2 Edition) E - Nikita and stack 线段树好题

http://codeforces.com/contest/760/problem/E 题目大意:现在对栈有m个操作,但是顺序是乱的,现在每输入一个操作要求你输出当前的栈顶, 注意,已有操作要按它们的时间顺序进行. 思路:线段树好题啊啊,我们把push当成+1, pop当成-1,按操作的位置建立线段树,那么如何 寻找栈顶呢,我们计算每个点的后缀,栈顶就是下标最大的>0的后缀,我们拿后缀建立线段树, 剩下的就是区间加减法,和求区间最大值啦. #include<bits/stdc++.h>

CF #CROC 2016 - Elimination Round D. Robot Rapping Results Report 二分+拓扑排序

题目链接:http://codeforces.com/contest/655/problem/D 大意是给若干对偏序,问最少需要前多少对关系,可以确定所有的大小关系. 解法是二分答案,利用拓扑排序看是否所有关系被唯一确定.即任意一次只能有1个元素入度为0入队. 1 #include <iostream> 2 #include <vector> 3 #include <algorithm> 4 #include <string> 5 #include <

CROC 2016 - Elimination Round Mischievous Mess Makers

这个题的意思是给你一个自然数序列1-n, 然后让你交换其中的一些数使得新序列的逆序对个数最大,  直接推公式即可, 代码如下: #include <bits/stdc++.h> using namespace std; typedef long long LL; int main() { int n, k; scanf("%d%d", &n, &k); LL pa = min(n/2, k); LL res1 = (n-2*pa)*pa; LL res2 =

VK Cup 2016 - Qualification Round 1 - D. Running with Obstacles

题意 : 在 x 坐标轴上,从 0 到 m 点,中途有 n 个障碍,遇到障碍可以 跳,但是每次跳之前需要一段 距离为 s 的“助跑 ”,而且每次跳跃距离不能超过 d ,不能落在障碍点上:给出 n,m,s,d,接下来 n 个数 ,表示障碍的坐标.输入保证起点和终点不会有障碍,不会有两个障碍在同一位置. 输出到达终点的过程.如果不能到达终点输出“IMPOSSIBLE” . 解题: 模拟啊模拟(好烦好烦= =) 首先 他一定是跑到距离障碍最近的位置才跳的,这样可以跳的更远些.然后两个障碍之间相距 要大

CROC 2016 - Elimination Round Enduring Exodus

这道题的意思是给你一串01序列, 0代表空房子, 1代表非空的房子, 农夫约翰和他的K个牛要住进空房子里面,i房子和j房子的距离是|j-i| 问农夫约翰和他的最远的牛的最小值是多少? 我们可以枚举牛的起点, 算出终点然后二分农夫约翰的位置, 代码如下: #include <bits/stdc++.h> using namespace std; int a[100000 + 100], na; int Binary(int num) { //找出<=num的最后一个位置 int l=0,